/***************************************************************************
                          collision.h  -  description
                             -------------------
    begin                : Sun Apr 6 2003
    copyright            : (C) 2003 by Steven Goodwin
    email                : 
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#ifndef _COLLISION_H
#define _COLLISION_H

BOOL 			exDoBoxesIntersect(const SDL_Rect *p1, const SDL_Rect *p2);
void 			exBuildRect4Tile(SDL_Rect *pRc, int tx, int ty);

void 			exInitCollisionList(EX_COLLISION_LIST *pCList);
void 			exAddCollision(EX_COLLISION_LIST *pCList, const EX_COLLISION *pCurr);

int 			exGetRectCollision(const EX_OBJECT *pIgnoreObj, const SDL_Rect *pRc, EX_COLLISION_LIST *pCollisionList);
int 			exCheckCollision(EX_COLLISION_LIST *pCollisionList);

BOOL 			exCCBoundingBox(const SDL_Rect *pRc, const SDL_Rect *pEnemy, const EX_OBJECT *pObj, EX_COLLISION_LIST *pCList);
BOOL 			exCCBoundingBox2Pixel(const SDL_Rect *pRc, const SDL_Rect *pEnemyRc, const Uint8 *pColSurface, int iRegion, const EX_OBJECT *pObj, EX_COLLISION_LIST *pCList);

Uint8 	*exCUBuildCollisionSurface(SDL_Surface *pCurr);
void 			exCUDestroyCollisionSurface(Uint8 *pCurr);

#endif /* _COLLISION_H */
